Index: /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_latency_bandwidth.py
===================================================================
--- /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_latency_bandwidth.py	(revision 8070)
+++ /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_latency_bandwidth.py	(revision 8071)
@@ -37,7 +37,11 @@
     results = []
     #machines_file = os.path.join('~', '.machines_%s' % cluster)
-    for num_procs in Processor_Numbers:
-        cmd = ('mpirun -nolocal -np %2d -hostfile %s %s'
-               % (num_procs, util.machines_file, obj_file))
+    for num_procs in Processor_Numbers: 
+        if cluster == 'cen-4470-test':
+            cmd = ('mpirun -np %2d %s'
+                   % (num_procs, obj_file))
+        else:
+            cmd = ('mpirun -nolocal -np %2d -hostfile %s %s'
+                   % (num_procs, util.machines_file, obj_file))
         util.log_print(logfile, cmd + ' ...')
         (_, fd) = os.popen4(cmd)
Index: /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_python_packages.py
===================================================================
--- /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_python_packages.py	(revision 8070)
+++ /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_python_packages.py	(revision 8071)
@@ -18,5 +18,5 @@
                    'import matplotlib',
                    'import pylab',
-                   'import wxPython',
+                   'import wx',
                    'import sqlalchemy',
                   )
Index: /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_quadrature_parallel_interleaved.py
===================================================================
--- /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_quadrature_parallel_interleaved.py	(revision 8070)
+++ /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_quadrature_parallel_interleaved.py	(revision 8071)
@@ -7,5 +7,5 @@
 import test_utils as util
 
-Processor_Numbers = [1, 2, 4, 8, 16]
+Processor_Numbers = [1, 2, 4, 5, 8, 16, 32, 38, 64, 76]
 
 name = 'Running quadrature parallel interleaved test'
@@ -15,5 +15,6 @@
 
     (cluster, domain) = util.get_hostname()
-
+    print "cluster", cluster
+    print "domain", domain
     # get python to run
     python_env_var = os.getenv('PYTHON')
@@ -39,7 +40,11 @@
     #machines_file = os.path.join('machines_%s' % cluster)
     single_processor_time = None
-    for num_procs in Processor_Numbers:
-        cmd = ('mpirun -nolocal -np %2d -hostfile %s %s'
-               % (num_procs, util.machines_file, obj_file))
+    for num_procs in Processor_Numbers:  
+        if cluster == 'cen-4470-test':
+            cmd = ('mpirun -np %2d %s'
+                   % (num_procs, obj_file))
+        else:
+            cmd = ('mpirun -nolocal -np %2d -hostfile %s %s'
+                   % (num_procs, util.machines_file, obj_file))
         util.log_print(logfile, cmd + ' ...')
         (_, fd) = os.popen4(cmd)
Index: /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_test_pypar.py
===================================================================
--- /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_test_pypar.py	(revision 8070)
+++ /branches/anuga_1_2_0/misc/tools/acceptance_tests/test_test_pypar.py	(revision 8071)
@@ -7,5 +7,5 @@
 import test_utils as util
 
-Processor_Numbers = [1, 2, 4, 8, 16]
+Processor_Numbers = [1, 20, 24, 28, 30, 32]
 
 name = 'Running pypar test'
@@ -18,10 +18,16 @@
     # get python to run
     python_env_var = os.getenv('PYTHON')
+    if python_env_var is None:
+        python_env_var = 'python'
 
     # run the test_pypar.py tests
     #machines_file = os.path.join('~', '.machines_%s' % cluster)
-    for num_procs in Processor_Numbers:
-        cmd = ('mpirun -nolocal -np %2d -hostfile %s %s test_pypar.py'
-               % (num_procs, util.machines_file, python_env_var))
+    for num_procs in Processor_Numbers: 
+        if cluster == 'cen-4470-test':
+            cmd = ('mpirun -np %2d %s test_pypar.py'
+                   % (num_procs, python_env_var))
+        else:
+            cmd = ('mpirun -nolocal -np %2d -hostfile %s %s test_pypar.py'
+                   % (num_procs, util.machines_file, python_env_var))
         util.log_print(logfile, cmd + ' ...')
         fd = os.popen(cmd)
@@ -69,6 +75,10 @@
     machines_file = os.path.join('..', util.machines_file)
     result_data = []
-    for num_procs in Processor_Numbers:
-        cmd = ('mpirun -nolocal -np %2d -hostfile %s %s mandel_parallel_cyclic.py'
+    for num_procs in Processor_Numbers: 
+        if cluster == 'cen-4470-test':
+            cmd = ('mpirun -np %2d %s mandel_parallel_cyclic.py'
+                   % (num_procs, python_env_var))
+        else:
+            cmd = ('mpirun -nolocal -np %2d -hostfile %s %s mandel_parallel_cyclic.py'
                % (num_procs, machines_file, python_env_var))
         util.log_print(logfile, cmd + ' ...')