Index: /trunk/anuga_core/source/anuga/culvert_flows/test_all.py
===================================================================
--- /trunk/anuga_core/source/anuga/culvert_flows/test_all.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/culvert_flows/test_all.py	(revision 8150)
@@ -28,10 +28,4 @@
 
 
-##
-# @brief List a string sequence on the screen in columns.
-# @param names Sequence of strings to list.
-# @param func Function to apply to each string in sequence.
-# @param col_width Force columns to this width (default calculated).
-# @param page_width Set displayable page width to this (default 132).
 def list_names(names, func=None, col_width=None, page_width=None):
     # set defaults
@@ -68,9 +62,4 @@
 
 
-##
-# @brief Get 'test_*.py' files and paths to directories.
-# @param path Path to directory to start walk in.
-# @return A tuple (<files>, <dirs>).
-# @note Don't include any files in and below forbidden directories.
 def get_test_files(path):
     walk = os.walk(path)
@@ -175,7 +164,4 @@
 
 
-##
-# @brief Check that the environment is sane.
-# @note Stops here if there is an error.
 def check_anuga_import():
     try:
Index: /trunk/anuga_core/source/anuga/file_conversion/asc2dem.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/asc2dem.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/file_conversion/asc2dem.py	(revision 8150)
@@ -55,9 +55,4 @@
 
 
-##
-# @brief Convert an ASC file to a DEM file.
-# @param basename_in Stem of input filename.
-# @param basename_out Stem of output filename.
-# @param verbose True if this function is to be verbose.
 def _convert_dem_from_ascii2netcdf(name_in, name_out = None,
                                    verbose = False):
Index: /trunk/anuga_core/source/anuga/file_conversion/dem2pts.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/dem2pts.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/file_conversion/dem2pts.py	(revision 8150)
@@ -53,13 +53,4 @@
 
 
-##
-# @brief 
-# @param basename_in 
-# @param basename_out 
-# @param verbose 
-# @param easting_min 
-# @param easting_max 
-# @param northing_min 
-# @param northing_max 
 def _dem2pts(name_in, name_out=None, verbose=False,
             easting_min=None, easting_max=None,
Index: /trunk/anuga_core/source/anuga/file_conversion/file_conversion.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/file_conversion.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/file_conversion/file_conversion.py	(revision 8150)
@@ -86,9 +86,4 @@
         write_obj(FN, xx, yy, zz)
 
-##
-# @brief Convert time-series text file to TMS file.
-# @param filename 
-# @param quantity_names 
-# @param time_as_seconds 
 def timefile2netcdf(file_text, file_out = None, quantity_names=None, \
                                 time_as_seconds=False):
@@ -224,8 +219,4 @@
     
 
-##
-# @brief 
-# @param filename
-# @param verbose
 def tsh2sww(filename, verbose=False):
     """
@@ -266,13 +257,4 @@
 
 
-##
-# @brief Return max&min indexes (for slicing) of area specified.
-# @param latitudes_ref ??
-# @param longitudes_ref ??
-# @param minlat Minimum latitude of specified area.
-# @param maxlat Maximum latitude of specified area.
-# @param minlon Minimum longitude of specified area.
-# @param maxlon Maximum longitude of specified area.
-# @return Tuple (lat_min_index, lat_max_index, lon_min_index, lon_max_index)
 def get_min_max_indices(latitudes_ref, longitudes_ref,
                          minlat=None, maxlat=None,
@@ -350,10 +332,4 @@
 
 
-##
-# @brief 
-# @param filename 
-# @param x 
-# @param y 
-# @param z 
 def write_obj(filename, x, y, z):
     """Store x,y,z vectors into filename (obj format).
Index: /trunk/anuga_core/source/anuga/file_conversion/sdf2pts.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/sdf2pts.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/file_conversion/sdf2pts.py	(revision 8150)
@@ -3,8 +3,4 @@
 from anuga.geospatial_data.geospatial_data import Geospatial_data
 
-##
-# @brief  Return block of surface lines for each cross section
-# @param lines Iterble  of text lines to process.
-# @note BROKEN?  UNUSED?
 def _read_hecras_cross_sections(lines):
     """Return block of surface lines for each cross section
@@ -43,8 +39,7 @@
     """Read HEC-RAS Elevation datal from the following ASCII format (.sdf)
 
-# @brief Convert HECRAS (.sdf) file to PTS file.
-# @param basename_in Sterm of input filename.
-# @param basename_out Sterm of output filename.
-# @param verbose True if this function is to be verbose.
+    basename_in Sterm of input filename.
+    basename_out Sterm of output filename.
+    verbose True if this function is to be verbose.
 
     Example:
Index: /trunk/anuga_core/source/anuga/file_conversion/urs2nc.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/urs2nc.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/file_conversion/urs2nc.py	(revision 8150)
@@ -64,10 +64,4 @@
 
 
-##
-# @brief Convert a quantity URS file to a NetCDF file.
-# @param file_in Path to input URS file.
-# @param file_out Path to the output file.
-# @param quantity Name of the quantity to be written to the output file.
-# @return A tuple (lonlatdep, lon, lat, depth).
 def _binary_c2nc(file_in, file_out, quantity):
     """Reads in a quantity urs file and writes a quantity nc file.
@@ -140,9 +134,4 @@
 
 
-##
-# @brief 
-# @param long_lat_dep 
-# @return A tuple (long, lat, quantity).
-# @note The latitude is the fastest varying dimension - in mux files.
 def lon_lat2grid(long_lat_dep):
     """
Index: /trunk/anuga_core/source/anuga/geometry/polygon.py
===================================================================
--- /trunk/anuga_core/source/anuga/geometry/polygon.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/geometry/polygon.py	(revision 8150)
@@ -13,11 +13,4 @@
 from aabb import AABB
 
-##
-# @brief Determine whether a point is on a line segment.
-# @param point (x, y) of point in question (tuple, list or array).
-# @param line ((x1,y1), (x2,y2)) for line (tuple, list or array).
-# @param rtol Relative error for 'close'.
-# @param atol Absolute error for 'close'.
-# @return True or False.
 def point_on_line(point, line, rtol=1.0e-5, atol=1.0e-8):
     """Determine whether a point is on a line segment
@@ -98,16 +91,4 @@
    }
 
-##
-# @brief Finds intersection point of two line segments.
-# @param line0 First line ((x1,y1), (x2,y2)).
-# @param line1 Second line ((x1,y1), (x2,y2)).
-# @param rtol Relative error for 'close'.
-# @param atol Absolute error for 'close'.
-# @return (status, value) where:
-#             status = 0 - no intersection, value set to None
-#                      1 - intersection found, value=(x,y)
-#                      2 - lines collienar, overlap, value=overlap segment
-#                      3 - lines collinear, no overlap, value is None
-#                      4 - lines parallel, value is None
 def intersection(line0, line1, rtol=1.0e-5, atol=1.0e-8):
     """Returns intersecting point between two line segments.
@@ -180,15 +161,4 @@
             return 0, None
 
-##
-# @brief Finds intersection point of two line segments.
-# @param line0 First line ((x1,y1), (x2,y2)).
-# @param line1 Second line ((x1,y1), (x2,y2)).
-# @return (status, value) where:
-#             status = 0 - no intersection, value set to None
-#                      1 - intersection found, value=(x,y)
-#                      2 - lines collienar, overlap, value=overlap segment
-#                      3 - lines collinear, no overlap, value is None
-#                      4 - lines parallel, value is None
-# @note Wrapper for C function.
 def NEW_C_intersection(line0, line1):
     """Returns intersecting point between two line segments.
@@ -436,11 +406,4 @@
         raise Exception(msg)
 
-##
-# @brief Determine which of a set of points are inside a polygon.
-# @param points A set of points (tuple, list or array).
-# @param polygon A set of points defining a polygon (tuple, list or array).
-# @param closed True if points on boundary are considered 'inside' polygon.
-# @param verbose True if this function is to be verbose.
-# @return A list of indices of points inside the polygon.
 def inside_polygon(points, polygon, closed=True, verbose=False):
     """Determine points inside a polygon
@@ -489,12 +452,4 @@
     return indices[:count]
 
-##
-# @brief Determine if one point is outside a polygon.
-# @param point The point of interest.
-# @param polygon The polygon to test inclusion in.
-# @param closed True if points on boundary are considered 'inside' polygon.
-# @param verbose True if this function is to be verbose.
-# @return True if point is outside the polygon.
-# @note Uses inside_polygon() to do the work.
 def is_outside_polygon(point, polygon, closed=True, verbose=False,
                        points_geo_ref=None, polygon_geo_ref=None):
@@ -514,11 +469,4 @@
         raise Exception, msg
 
-##
-# @brief Determine which of a set of points are outside a polygon.
-# @param points A set of points (tuple, list or array).
-# @param polygon A set of points defining a polygon (tuple, list or array).
-# @param closed True if points on boundary are considered 'inside' polygon.
-# @param verbose True if this function is to be verbose.
-# @return A list of indices of points outside the polygon.
 def outside_polygon(points, polygon, closed = True, verbose = False):
     """Determine points outside a polygon
@@ -562,11 +510,4 @@
         return indices[count:][::-1]  #return reversed
 
-##
-# @brief Separate a list of points into two sets inside+outside a polygon.
-# @param points A set of points (tuple, list or array).
-# @param polygon A set of points defining a polygon (tuple, list or array).
-# @param closed True if points on boundary are considered 'inside' polygon.
-# @param verbose True if this function is to be verbose.
-# @return A tuple (in, out) of point indices for poinst inside amd outside.
 def in_and_outside_polygon(points, polygon, closed=True, verbose=False):
     """Determine points inside and outside a polygon
@@ -1055,9 +996,9 @@
     the extrema in both axes are preserved.
 
-##
-# @brief Reduce number of points in polygon by the specified factor.
-# @param polygon The polygon to reduce.
-# @param factor The factor to reduce polygon points by (default 10).
-# @note The extrema of both axes are preserved.
+    Reduce number of points in polygon by the specified factor.
+    polygon The polygon to reduce.
+    factor The factor to reduce polygon points by (default 10).
+
+    The extrema of both axes are preserved.
 
     Return reduced polygon
Index: /trunk/anuga_core/source/anuga/geometry/polygon_function.py
===================================================================
--- /trunk/anuga_core/source/anuga/geometry/polygon_function.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/geometry/polygon_function.py	(revision 8150)
@@ -44,9 +44,9 @@
 
     def __init__(self, regions, default=0.0, geo_reference=None):
-        """
-        # @brief Create instance of a polygon function.
-        # @param regions A list of (x,y) tuples defining a polygon.
-        # @param default Value or function returning value for points outside poly.
-        # @param geo_reference ??
+        """Create instance of a polygon function.
+
+        regions A list of (x,y) tuples defining a polygon.
+        default Value or function returning value for points outside poly.
+        geo_reference ??
         """
 
@@ -90,8 +90,8 @@
 
     def __call__(self, pts_x, pts_y):
-        """
-        # @brief Implement the 'callable' property of Polygon_function.
-        # @param x List of x coordinates of points ot interest.
-        # @param y List of y coordinates of points ot interest.
+        """Implement the 'callable' property of Polygon_function.
+
+        x List of x coordinates of points ot interest.
+        y List of y coordinates of points ot interest.
         """
         pts_x = num.array(pts_x, num.float)
Index: /trunk/anuga_core/source/anuga/load_mesh/loadASCII.py
===================================================================
--- /trunk/anuga_core/source/anuga/load_mesh/loadASCII.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/load_mesh/loadASCII.py	(revision 8150)
@@ -80,10 +80,4 @@
 
 
-##
-# @brief Read a mesh file (.tsh or .msh) and return a dictionary.
-# @param ofile Path to the file to read.
-# @return A dictionary of data from the input file.
-# @note Throws IOError if can't read file.
-# @note This is used by pmesh.
 def import_mesh_file(ofile):
     """Read a mesh file, either .tsh or .msh
@@ -107,9 +101,4 @@
 
 
-##
-# @brief Write a mesh file from a dictionary.
-# @param ofile The path of the mesh file to write.
-# @param mesh_dict Dictionary containing data to write to output mesh file.
-# @note Raises IOError if file extension is unrecognized.
 def export_mesh_file(ofile, mesh_dict):
     """Write a mesh file given a dictionary.
@@ -148,8 +137,4 @@
 
 
-##
-# @brief Read a mesh file into a dictionary.
-# @param ofile Path of the file to read.
-# @return Points dictionary from the mesh (.tsh) file.
 def _read_tsh_file(ofile):
     """Read the text file format for meshes"""
@@ -165,8 +150,4 @@
 
 
-##
-# @brief Read triangulation data from a file, leave file open.
-# @param fd An open descriptor of the file to read.
-# @return A dictionary ...
 def _read_triangulation(fd):
     """Read the generated triangulation, NOT the outline."""
@@ -265,9 +246,4 @@
 
 
-##
-# @brief Read a mesh outline file.
-# @param fd An open descriptor of the file to read.
-# @return A Points dictionary.
-# @note If file has no mesh info, an empty dict will be returned.
 def _read_outline(fd):
     """Read a mesh file outline.
@@ -397,8 +373,4 @@
 
 
-##
-# @brief Write an ASCII triangulation file.
-# @param fd An open descriptor to the file to write.
-# @param gen_dict Dictionary containing data to write.
 def _write_ASCII_triangulation(fd, gen_dict):
     vertices = gen_dict['vertices']
@@ -510,8 +482,4 @@
 
 
-##
-# @brief Write triangulation and outline to a .tsh file.
-# @param ofile Path of the file to write.
-# @mesh_dict Dictionary of data to write.
 def _write_tsh_file(ofile, mesh_dict):
     fd = open(ofile, 'w')
@@ -521,8 +489,4 @@
 
 
-##
-# @brief Write an ASCII outline to a file.
-# @param fd An open descriptor of the file to write.
-# @param dict Dictionary holding data to write.
 def _write_ASCII_outline(fd, dict):
     points = dict['points']
@@ -597,8 +561,4 @@
 
 
-##
-# @brief Write a .msh file.
-# @param file Path to the file to write.
-# @param mesh Dictionary holding data to write.
 def _write_msh_file(file_name, mesh):
     """Write .msh NetCDF file
@@ -791,9 +751,4 @@
 
 
-##
-# @brief Read a mesh file.
-# @param file_name Path to the file to read.
-# @return A dictionary containing the .msh file data.
-# @note Throws IOError if file not found.
 def _read_msh_file(file_name):
     """ Read in an msh file."""
@@ -916,11 +871,4 @@
 
 
-##
-# @brief Export a boundary file.
-# @param file_name Path to the file to write.
-# @param points List of point index pairs.
-# @paran title Title string to write into file (first line).
-# @param delimiter Delimiter string to write between points.
-# @note Used by alpha shapes
 def export_boundary_file(file_name, points, title, delimiter=','):
     """Export a boundary file.
@@ -949,7 +897,4 @@
 ################################################################################
 
-##
-# @brief 
-# @param point_atts 
 def extent_point_atts(point_atts):
     """Returns 4 points representing the extent
@@ -963,9 +908,4 @@
 
 
-##
-# @brief Get an extent array for a set of points.
-# @param points A set of points.
-# @return An extent array of form [[min_x, min_y], [max_x, min_y],
-#                                  [max_x, max_y], [min_x, max_y]]
 def extent(points):
     points = num.array(points, num.float)
@@ -995,10 +935,4 @@
 
 
-##
-# @brief Reduce a points file until number of points is less than limit.
-# @param infile Path to input file to thin.
-# @param outfile Path to output thinned file.
-# @param max_points Max number of points in output file.
-# @param verbose True if this function is to be verbose.
 def reduce_pts(infile, outfile, max_points, verbose = False):
     """Reduce a points file until less than given size.
@@ -1019,11 +953,4 @@
 
 
-##
-# @brief 
-# @param infile 
-# @param max_points 
-# @param delimiter 
-# @param verbose True if this function is to be verbose.
-# @return A list of 
 def produce_half_point_files(infile, max_points, delimiter, verbose=False):
     point_atts = _read_pts_file(infile)
@@ -1046,8 +973,4 @@
 
 
-##
-# @brief 
-# @param point_atts Object with attribute of 'pointlist'.
-# @return 
 def point_atts2array(point_atts):
     # convert attribute list to array of floats
@@ -1061,8 +984,4 @@
 
 
-##
-# @brief ??
-# @param point_atts ??
-# @return ??
 def half_pts(point_atts):
     point_atts2array(point_atts)
@@ -1074,8 +993,4 @@
     return point_atts
 
-##
-# @brief ??
-# @param dic ??
-# @return ??
 def concatinate_attributelist(dic):
     """
@@ -1095,10 +1010,4 @@
 
 
-##
-# @brief 
-# @param dict 
-# @param indices_to_keep 
-# @return 
-# @note FIXME(dsg), turn this dict plus methods into a class?
 def take_points(dict, indices_to_keep):
     dict = point_atts2array(dict)
@@ -1112,9 +1021,4 @@
     return dict
 
-##
-# @brief ??
-# @param dict1 ??
-# @param dict2 ??
-# @return ??
 def add_point_dictionaries(dict1, dict2):
     """
Index: /trunk/anuga_core/source/anuga/test_all.py
===================================================================
--- /trunk/anuga_core/source/anuga/test_all.py	(revision 8149)
+++ /trunk/anuga_core/source/anuga/test_all.py	(revision 8150)
@@ -28,10 +28,4 @@
 
 
-##
-# @brief List a string sequence on the screen in columns.
-# @param names Sequence of strings to list.
-# @param func Function to apply to each string in sequence.
-# @param col_width Force columns to this width (default calculated).
-# @param page_width Set displayable page width to this (default 132).
 def list_names(names, func=None, col_width=None, page_width=None):
     # set defaults
@@ -176,7 +170,4 @@
 
 
-##
-# @brief Check that the environment is sane.
-# @note Stops here if there is an error.
 def check_anuga_import():
     try: